Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/dynredem_loc.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/dynredem_loc.F90	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/dynredem_loc.F90	(revision 5101)
@@ -11,5 +11,5 @@
   USE strings_mod, ONLY: maxlen
   USE infotrac, ONLY: nqtot, tracers
-  USE netcdf, ONLY: nf90_create, nf90_def_dim, NF90_INQ_VARID, nf90_global,    &
+  USE netcdf, ONLY: nf90_create, nf90_def_dim, nf90_inq_varid, nf90_global,    &
                     nf90_close,  nf90_put_att, nf90_unlimited, nf90_clobber,   &
                     nf90_64bit_offset
@@ -178,6 +178,6 @@
   USE infotrac, ONLY: nqtot, tracers, type_trac
   USE control_mod
-  USE netcdf,   ONLY: nf90_open,  nf90_nowrite, nf90_get_var, NF90_INQ_VARID,  &
-                      nf90_close, NF90_WRITE,   nf90_put_var, nf90_noerr
+  USE netcdf,   ONLY: nf90_open,  nf90_nowrite, nf90_get_var, nf90_inq_varid,  &
+                      nf90_close, nf90_write,   nf90_put_var, nf90_noerr
   USE dynredem_mod, ONLY: dynredem_write_u, dynredem_write_v, dynredem_read_u, &
                           err, modname, fil, msg
@@ -213,10 +213,10 @@
   IF(mpi_rank==0) THEN !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   modname='dynredem1_loc'; fil=fichnom
-  CALL err(nf90_open(fil,NF90_WRITE,nid),"open",fil)
+  CALL err(nf90_open(fil,nf90_write,nid),"open",fil)
 
 !--- Write/extend time coordinate
   nb = nb + 1
   var="temps"
-  CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
+  CALL err(nf90_inq_varid(nid,var,vID),"inq",var)
   CALL err(nf90_put_var(nid,vID,[time]),"put",var)
   WRITE(lunout,*)TRIM(modname)//": Saving for ", nb, time
@@ -224,8 +224,8 @@
 !--- Rewrite control table (itaufin undefined in dynredem0)
   var="controle"
-  CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
+  CALL err(nf90_inq_varid(nid,var,vID),"inq",var)
   CALL err(nf90_get_var(nid,vID,tab_cntrl),"get",var)
   tab_cntrl(31)=DBLE(itau_dyn + itaufin)
-  CALL err(NF90_INQ_VARID(nid,var,vID),"inq",var)
+  CALL err(nf90_inq_varid(nid,var,vID),"inq",var)
   CALL err(nf90_put_var(nid,vID,tab_cntrl),"put",var)
   END IF               !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
@@ -253,5 +253,5 @@
 !$OMP MASTER      
       fil="start_trac.nc"
-      ierr=NF90_INQ_VARID(nid_trac,var,vID_trac)
+      ierr=nf90_inq_varid(nid_trac,var,vID_trac)
       dum='inq'; IF(ierr==nf90_noerr) dum='fnd'
       WRITE(lunout,*)msg(dum,var)
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/dynredem_mod.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/dynredem_mod.F90	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/dynredem_mod.F90	(revision 5101)
@@ -37,5 +37,5 @@
 
 !$OMP MASTER
-  IF(mpi_rank==0) CALL err(NF90_INQ_VARID(ncid,id,nvarid),"inq",id)
+  IF(mpi_rank==0) CALL err(nf90_inq_varid(ncid,id,nvarid),"inq",id)
 !$OMP END MASTER
 
@@ -87,5 +87,5 @@
 
 !$OMP MASTER
-  IF(mpi_rank==0) CALL err(NF90_INQ_VARID(ncid,id,nvarid),"inq",id)
+  IF(mpi_rank==0) CALL err(nf90_inq_varid(ncid,id,nvarid),"inq",id)
 !$OMP END MASTER
 
@@ -137,5 +137,5 @@
 
 !$OMP MASTER
-  IF(mpi_rank==0) CALL err(NF90_INQ_VARID(ncid,id,nvarid),'inq',id)
+  IF(mpi_rank==0) CALL err(nf90_inq_varid(ncid,id,nvarid),'inq',id)
 !$OMP END MASTER
 
@@ -213,5 +213,5 @@
   IF(nd==1) CALL err(nf90_put_var(ncid,nvarid,RESHAPE(v,nn(1:1))),var)
   IF(nd==2) CALL err(nf90_put_var(ncid,nvarid,RESHAPE(v,nn(1:2))),var)
-  CALL err(NF90_REDEF(ncid))
+  CALL err(nf90_redef(ncid))
 END SUBROUTINE put_var
 
@@ -260,5 +260,5 @@
   IF(ierr==nf90_noerr) RETURN
   IF(.NOT.PRESENT(typ)) THEN
-    CALL ABORT_gcm(modname,NF90_STRERROR(ierr),ierr)
+    CALL ABORT_gcm(modname,nf90_strerror(ierr),ierr)
   ELSE
     CALL ABORT_gcm(modname,msg(typ,nam),ierr)
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/exner_hyb_loc_m.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/exner_hyb_loc_m.F90	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/exner_hyb_loc_m.F90	(revision 5101)
@@ -5,5 +5,5 @@
 contains
 
-  SUBROUTINE  exner_hyb_loc(ngrid, ps, p, pks,pk,pkf)
+  SUBROUTINE  exner_hyb_loc(ngrid, ps, p, pks, pk, pkf)
 
     !     Auteurs :  P.Le Van  , Fr. Hourdin  .
@@ -14,5 +14,5 @@
 
     !   ************************************************************************
-    !    Calcule la fonction d'Exner pk = Cp * (p/preff) ** kappa , aux milieux des 
+    !    Calcule la fonction d'Exner pk = Cp * (p/preff) ** kappa , aux milieux des
     !    couches .   Pk(l) sera calcule aux milieux  des couches l ,entre les
     !    pressions p(l) et p(l+1) ,definis aux interfaces des llm couches .
@@ -26,9 +26,8 @@
     !    ( voir note de Fr.Hourdin )  ,
 
-    !    on determine successivement , du haut vers le bas des couches, les 
-    !    coef. alpha(llm),beta(llm) .,.,alpha(l),beta(l),,,alpha(2),beta(2), 
-    !    puis pk(ij,1). Ensuite ,on calcule,du bas vers le haut des couches,  
+    !    on determine successivement , du haut vers le bas des couches, les
+    !    coef. alpha(llm),beta(llm) .,.,alpha(l),beta(l),,,alpha(2),beta(2),
+    !    puis pk(ij,1). Ensuite ,on calcule,du bas vers le haut des couches,
     !     pk(ij,l)  donne  par la relation (2),  pour l = 2 a l = llm .
-
 
     USE parallel_lmdz
@@ -37,5 +36,6 @@
     USE comconst_mod, ONLY: cpp, kappa, r, jmp1
     USE comvert_mod, ONLY: preff
-    
+    USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_DEBUGIO
+
     IMPLICIT NONE
 
@@ -45,36 +45,36 @@
 
     INTEGER  ngrid
-    REAL p(ijb_u:ije_u,llmp1),pk(ijb_u:ije_u,llm)
-    REAL, optional:: pkf(ijb_u:ije_u,llm)
-    REAL ps(ijb_u:ije_u),pks(ijb_u:ije_u)
-    REAL alpha(ijb_u:ije_u,llm),beta(ijb_u:ije_u,llm)
+    REAL p(ijb_u:ije_u, llmp1), pk(ijb_u:ije_u, llm)
+    REAL, optional :: pkf(ijb_u:ije_u, llm)
+    REAL ps(ijb_u:ije_u), pks(ijb_u:ije_u)
+    REAL alpha(ijb_u:ije_u, llm), beta(ijb_u:ije_u, llm)
 
     !    .... variables locales   ...
 
     INTEGER l, ij
-    REAL unpl2k,dellta
+    REAL unpl2k, dellta
 
-    INTEGER ije,ijb,jje,jjb
-    logical,save :: firstcall=.true.
-    !$OMP THREADPRIVATE(firstcall) 
-    character(len=*),parameter :: modname="exner_hyb_loc"
+    INTEGER ije, ijb, jje, jjb
+    logical, save :: firstcall = .true.
+    !$OMP THREADPRIVATE(firstcall)
+    character(len = *), parameter :: modname = "exner_hyb_loc"
 
-    !$OMP BARRIER           
+    !$OMP BARRIER
 
     ! Sanity check
     if (firstcall) then
-       ! sanity checks for Shallow Water case (1 vertical layer)
-       if (llm==1) then
-          if (kappa/=1) then
-             call abort_gcm(modname, &
-                  "kappa!=1 , but running in Shallow Water mode!!",42)
-          endif
-          if (cpp/=r) then
-             call abort_gcm(modname, &
-                  "cpp!=r , but running in Shallow Water mode!!",42)
-          endif
-       endif ! of if (llm.eq.1)
+      ! sanity checks for Shallow Water case (1 vertical layer)
+      if (llm==1) then
+        if (kappa/=1) then
+          CALL abort_gcm(modname, &
+                  "kappa!=1 , but running in Shallow Water mode!!", 42)
+        endif
+        if (cpp/=r) then
+          CALL abort_gcm(modname, &
+                  "cpp!=r , but running in Shallow Water mode!!", 42)
+        endif
+      endif ! of if (llm.eq.1)
 
-       firstcall=.false.
+      firstcall = .false.
     endif ! of if (firstcall)
 
@@ -84,30 +84,30 @@
     if (llm==1) then
 
-       ! Compute pks(:),pk(:),pkf(:)
-       ijb=ij_begin
-       ije=ij_end
-       !$OMP DO SCHEDULE(STATIC)
-       DO ij=ijb, ije
-          pks(ij) = (cpp/preff) * ps(ij)
-          pk(ij,1) = .5*pks(ij)
-          if (present(pkf)) pkf(ij,1)=pk(ij,1)
-       ENDDO
-       !$OMP ENDDO
+      ! Compute pks(:),pk(:),pkf(:)
+      ijb = ij_begin
+      ije = ij_end
+      !$OMP DO SCHEDULE(STATIC)
+      DO ij = ijb, ije
+        pks(ij) = (cpp / preff) * ps(ij)
+        pk(ij, 1) = .5 * pks(ij)
+        if (present(pkf)) pkf(ij, 1) = pk(ij, 1)
+      ENDDO
+      !$OMP ENDDO
 
-       !$OMP BARRIER
-       if (present(pkf)) then
-          jjb=jj_begin
-          jje=jj_end
-          CALL filtreg_p ( pkf,jjb_u,jje_u,jjb,jje, jmp1, llm, &
-               2, 1, .TRUE., 1 )
-       end if
+      !$OMP BARRIER
+      if (present(pkf)) then
+        jjb = jj_begin
+        jje = jj_end
+        CALL filtreg_p (pkf, jjb_u, jje_u, jjb, jje, jmp1, llm, &
+                2, 1, .TRUE., 1)
+      end if
 
-       ! our work is done, exit routine
-       return
+      ! our work is done, exit routine
+      return
     endif ! of if (llm.eq.1)
 
     ! General case:
 
-    unpl2k    = 1.+ 2.* kappa
+    unpl2k = 1. + 2. * kappa
 
     !     -------------
@@ -115,10 +115,10 @@
     !     -------------
 
-    ijb=ij_begin
-    ije=ij_end
+    ijb = ij_begin
+    ije = ij_end
 
     !$OMP DO SCHEDULE(STATIC)
-    DO   ij  = ijb, ije
-       pks(ij) = cpp * ( ps(ij)/preff ) ** kappa
+    DO   ij = ijb, ije
+      pks(ij) = cpp * (ps(ij) / preff) ** kappa
     ENDDO
     !$OMP ENDDO
@@ -131,7 +131,7 @@
 
     !$OMP DO SCHEDULE(STATIC)
-    DO     ij      = ijb,ije
-       alpha(ij,llm) = 0.
-       beta (ij,llm) = 1./ unpl2k
+    DO     ij = ijb, ije
+      alpha(ij, llm) = 0.
+      beta (ij, llm) = 1. / unpl2k
     ENDDO
     !$OMP ENDDO NOWAIT
@@ -139,13 +139,13 @@
     !     ... Calcul des coeff. alpha et beta  pour l = llm-1  a l = 2 ...
 
-    DO l = llm -1 , 2 , -1
+    DO l = llm - 1, 2, -1
 
-       !$OMP DO SCHEDULE(STATIC)
-       DO ij = ijb, ije
-          dellta = p(ij,l)* unpl2k + p(ij,l+1)* ( beta(ij,l+1)-unpl2k )
-          alpha(ij,l)  = - p(ij,l+1) / dellta * alpha(ij,l+1)
-          beta (ij,l)  =   p(ij,l  ) / dellta   
-       ENDDO
-       !$OMP ENDDO NOWAIT
+      !$OMP DO SCHEDULE(STATIC)
+      DO ij = ijb, ije
+        dellta = p(ij, l) * unpl2k + p(ij, l + 1) * (beta(ij, l + 1) - unpl2k)
+        alpha(ij, l) = - p(ij, l + 1) / dellta * alpha(ij, l + 1)
+        beta (ij, l) = p(ij, l) / dellta
+      ENDDO
+      !$OMP ENDDO NOWAIT
     ENDDO
 
@@ -154,7 +154,7 @@
 
     !$OMP DO SCHEDULE(STATIC)
-    DO   ij   = ijb, ije
-       pk(ij,1) = ( p(ij,1)*pks(ij) - 0.5*alpha(ij,2)*p(ij,2) )  / &
-            (  p(ij,1)* (1.+kappa) + 0.5*( beta(ij,2)-unpl2k )* p(ij,2) )
+    DO   ij = ijb, ije
+      pk(ij, 1) = (p(ij, 1) * pks(ij) - 0.5 * alpha(ij, 2) * p(ij, 2)) / &
+              (p(ij, 1) * (1. + kappa) + 0.5 * (beta(ij, 2) - unpl2k) * p(ij, 2))
     ENDDO
     !$OMP ENDDO NOWAIT
@@ -163,34 +163,34 @@
 
     DO l = 2, llm
-       !$OMP DO SCHEDULE(STATIC)
-       DO   ij   = ijb, ije
-          pk(ij,l) = alpha(ij,l) + beta(ij,l) * pk(ij,l-1)
-       ENDDO
-       !$OMP ENDDO NOWAIT        
+      !$OMP DO SCHEDULE(STATIC)
+      DO   ij = ijb, ije
+        pk(ij, l) = alpha(ij, l) + beta(ij, l) * pk(ij, l - 1)
+      ENDDO
+      !$OMP ENDDO NOWAIT
     ENDDO
 
     if (present(pkf)) then
-       !    calcul de pkf
+      !    calcul de pkf
 
-       DO l = 1, llm
-          !$OMP DO SCHEDULE(STATIC)
-          DO   ij   = ijb, ije
-             pkf(ij,l)=pk(ij,l)
-          ENDDO
-          !$OMP ENDDO NOWAIT             
-       ENDDO
+      DO l = 1, llm
+        !$OMP DO SCHEDULE(STATIC)
+        DO   ij = ijb, ije
+          pkf(ij, l) = pk(ij, l)
+        ENDDO
+        !$OMP ENDDO NOWAIT
+      ENDDO
 
-       !$OMP BARRIER
+      !$OMP BARRIER
 
-       jjb=jj_begin
-       jje=jj_end
-#ifdef DEBUG_IO    
-       call WriteField_u('pkf',pkf)
-#endif
-       CALL filtreg_p ( pkf,jjb_u,jje_u,jjb,jje, jmp1, llm, &
-            2, 1, .TRUE., 1 )
-#ifdef DEBUG_IO    
-       call WriteField_u('pkf',pkf)
-#endif     
+      jjb = jj_begin
+      jje = jj_end
+      IF (CPPKEY_DEBUGIO) THEN
+        CALL WriteField_u('pkf', pkf)
+      END IF
+      CALL filtreg_p (pkf, jjb_u, jje_u, jjb, jje, jmp1, llm, &
+              2, 1, .TRUE., 1)
+      IF (CPPKEY_DEBUGIO) THEN
+        CALL WriteField_u('pkf', pkf)
+      END IF
     end if
 
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/exner_milieu_loc_m.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/exner_milieu_loc_m.F90	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/exner_milieu_loc_m.F90	(revision 5101)
@@ -60,9 +60,9 @@
        if (llm==1) then
           if (kappa/=1) then
-             call abort_gcm(modname, &
+             CALL abort_gcm(modname, &
                   "kappa!=1 , but running in Shallow Water mode!!",42)
           endif
           if (cpp/=r) then
-             call abort_gcm(modname, &
+             CALL abort_gcm(modname, &
                   "cpp!=r , but running in Shallow Water mode!!",42)
           endif
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/filtreg_p.F
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/filtreg_p.F	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/filtreg_p.F	(revision 5101)
@@ -3,5 +3,5 @@
       SUBROUTINE filtreg_p ( champ, ibeg, iend, nlat, nbniv, 
      &     ifiltre, iaire, griscal ,iter)
-      USE parallel_lmdz, only : OMP_CHUNK
+      USE parallel_lmdz, ONLY: OMP_CHUNK
       USE mod_filtre_fft
       USE timer_filtre
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/fluxstokenc_p.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/fluxstokenc_p.f90	(revision 5101)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/fluxstokenc_p.f90	(revision 5101)
@@ -0,0 +1,167 @@
+! $Id: caladvtrac_p.F 1299 2010-01-20 14:27:21Z fairhead $
+
+!
+!
+SUBROUTINE fluxstokenc_p(pbaru, pbarv, masse, teta, phi)
+  USE parallel_lmdz
+  USE control_mod, ONLY: iapp_tracvl, planet_type, iphysiq
+  USE caladvtrac_mod
+  USE mod_hallo
+  USE bands
+  USE times
+  USE Vampir
+  USE write_field_loc
+
+
+  IMPLICIT NONE
+  !
+  ! Auteurs:   F.Hourdin , P.Le Van, F.Forget, F.Codron
+  !
+  !=======================================================================
+  !
+  !   Shema de  Van Leer
+  !
+  !=======================================================================
+
+  include "dimensions.h"
+  include "paramet.h"
+  include "tracstoke.h"
+
+  !   Arguments:
+  !   ----------
+  REAL :: pbaru(ijb_u:ije_u, llm), pbarv(ijb_v:ije_v, llm)
+  REAL :: masse(ijb_u:ije_u, llm)
+  REAL :: teta(ijb_u:ije_u, llm)
+  REAL :: phi(ijb_u:ije_u, llm)
+
+  INTEGER, SAVE :: pasflx = 0
+  !$OMP THREADPRIVATE(pasflx)
+  INTEGER :: ijb, ije, ijbu, ijbv, ijeu, ijev, j
+  INTEGER :: ij, l
+  TYPE(Request), SAVE :: Request_vanleer
+  !$OMP THREADPRIVATE(Request_vanleer)
+
+
+
+  ! !write(*,*) 'caladvtrac 58: entree'
+  ijbu = ij_begin
+  ijeu = ij_end
+
+  ijbv = ij_begin - iip1
+  ijev = ij_end
+  if (pole_nord) ijbv = ij_begin
+  if (pole_sud)  ijev = ij_end - iip1
+
+  IF(pasflx==0) THEN
+    !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+    DO l = 1, llm
+      tetac(ijbu:ijeu, l) = 0.
+      phic(ijbu:ijeu, l) = 0.
+      pbarucc(ijbu:ijeu, l) = 0.
+      pbarvcc(ijbv:ijev, l) = 0.
+    ENDDO
+    !$OMP END DO NOWAIT
+  ENDIF
+
+  !   accumulation des flux de masse horizontaux
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l = 1, llm
+    DO ij = ijbu, ijeu
+      pbarucc(ij, l) = pbarucc(ij, l) + pbaru(ij, l)
+      tetac(ij, l) = tetac(ij, l) + teta(ij, l)
+      phic(ij, l) = phic(ij, l) + phi(ij, l)
+
+    ENDDO
+    DO ij = ijbv, ijev
+      pbarvcc(ij, l) = pbarvcc(ij, l) + pbarv(ij, l)
+    ENDDO
+  ENDDO
+  !$OMP END DO NOWAIT
+
+  !   selection de la masse instantannee des mailles avant le transport.
+  IF(pasflx==0) THEN
+
+    ijb = ij_begin
+    ije = ij_end
+
+    !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+    DO l = 1, llm
+      massec(ijb:ije, l) = masse(ijb:ije, l)
+    ENDDO
+    !$OMP END DO NOWAIT
+
+  ENDIF
+
+  pasflx = pasflx + 1
+
+
+  !   Test pour savoir si on advecte a ce pas de temps
+
+  IF (pasflx==(iphysiq * istphy)) THEN
+    ! !write(*,*) 'caladvtrac 133'
+    !$OMP MASTER
+    CALL suspend_timer(timer_caldyn)
+    !$OMP END MASTER
+
+    ijb = ij_begin
+    ije = ij_end
+
+
+    !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+    DO l = 1, llm
+      pbarucc(ijb:ije, l) = pbarucc(ijb:ije, l) / REAL(iphysiq * istphy)
+      tetac(ijb:ije, l) = tetac(ijb:ije, l) / REAL(iphysiq * istphy)
+      phic(ijb:ije, l) = phic(ijb:ije, l) / REAL(iphysiq * istphy)
+    ENDDO
+    !$OMP ENDDO NOWAIT
+
+    if (pole_sud) ije = ij_end - iip1
+
+    !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+    DO l = 1, llm
+      pbarvcc(ijb:ije, l) = pbarvcc(ijb:ije, l) / REAL(iphysiq * istphy)
+    ENDDO
+    !$OMP ENDDO NOWAIT
+
+
+    !$OMP BARRIER
+    CALL Register_Hallo_u(pbarucc, llm, 1, 1, 1, 1, Request_vanleer)
+    CALL Register_Hallo_v(pbarvcc, llm, 1, 1, 1, 1, Request_vanleer)
+    CALL SendRequest(Request_vanleer)
+    !$OMP BARRIER
+    CALL WaitRequest(Request_vanleer)
+    !$OMP BARRIER
+
+    !c   ..  Modif P.Le Van  ( 20/12/97 )  ....
+    !c
+
+    !   traitement des flux de masse avant advection.
+    ! 1. calcul de w
+    ! 2. groupement des mailles pres du pole.
+
+    CALL groupe_loc(massec, pbarucc, pbarvcc, pbarugg, pbarvgg, wgg)
+
+    ijb = ij_begin
+    ije = ij_end
+
+    !$OMP BARRIER
+    CALL WriteField_u('pbarug', pbarugg)
+    CALL WriteField_v('pbarvg', pbarvgg)
+    CALL WriteField_u('wg', wgg)
+    CALL WriteField_u('tetag', tetac)
+    CALL WriteField_u('phig', phic)
+    CALL WriteField_u('masseg', massec)
+
+
+    !$OMP MASTER
+    CALL Set_Distrib(distrib_caldyn)
+    CALL VTe(VThallo)
+    CALL resume_timer(timer_caldyn)
+    !$OMP END MASTER
+
+
+    !$OMP BARRIER
+    pasflx = 0
+  ENDIF ! if iadvtr.EQ.iapp_tracvl
+
+END SUBROUTINE fluxstokenc_p
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/friction_loc.F
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/friction_loc.F	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/friction_loc.F	(revision 5101)
@@ -55,9 +55,9 @@
       IF (firstcall) THEN
         ! set friction type
-        call getin("friction_type",friction_type)
+        CALL getin("friction_type",friction_type)
         if ((friction_type<0).or.(friction_type>1)) then
           abort_message="wrong friction type"
           write(lunout,*)'Friction: wrong friction type',friction_type
-          call abort_gcm(modname,abort_message,42)
+          CALL abort_gcm(modname,abort_message,42)
         endif
         firstcall=.false.
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/gcm.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/gcm.F90	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/gcm.F90	(revision 5101)
@@ -134,5 +134,5 @@
 
   CALL conf_gcm( 99, .TRUE. )
-  if (mod(iphysiq, iperiod) /= 0) call abort_gcm("conf_gcm", &
+  if (mod(iphysiq, iperiod) /= 0) CALL abort_gcm("conf_gcm", &
        "iphysiq must be a multiple of iperiod", 1)
 
@@ -143,6 +143,6 @@
   CALL init_const_mpi
 
-  call init_parallel
-  call Read_Distrib
+  CALL init_parallel
+  CALL Read_Distrib
 
 !#ifdef CPP_PHYS
@@ -156,14 +156,14 @@
 
   CALL set_bands
-  if (mpi_rank==0) call WriteBands
-  call Set_Distrib(distrib_caldyn)
+  if (mpi_rank==0) CALL WriteBands
+  CALL Set_Distrib(distrib_caldyn)
 
   !$OMP PARALLEL
-  call Init_Mod_hallo
+  CALL Init_Mod_hallo
   !$OMP END PARALLEL
 
   !#ifdef CPP_PHYS
   !c$OMP PARALLEL
-  !      call InitComgeomphy ! now done in iniphysiq
+  !      CALL InitComgeomphy ! now done in iniphysiq
   !c$OMP END PARALLEL 
   !#endif
@@ -177,18 +177,18 @@
 #ifdef CPP_IOIPSL
   if (calend == 'earth_360d') then
-     call ioconf_calendar('360_day')
+     CALL ioconf_calendar('360_day')
      write(lunout,*)'CALENDRIER CHOISI: Terrestre a 360 jours/an'
      xios_cal_type='d360'
   else if (calend == 'earth_365d') then
-     call ioconf_calendar('noleap')
+     CALL ioconf_calendar('noleap')
      write(lunout,*)'CALENDRIER CHOISI: Terrestre a 365 jours/an'
      xios_cal_type='noleap'
   else if (calend == 'gregorian') then
-     call ioconf_calendar('gregorian')
+     CALL ioconf_calendar('gregorian')
      write(lunout,*)'CALENDRIER CHOISI: Terrestre bissextile'
      xios_cal_type='gregorian'
   else
      abort_message = 'Mauvais choix de calendrier'
-     call abort_gcm(modname,abort_message,1)
+     CALL abort_gcm(modname,abort_message,1)
   endif
 #endif
@@ -200,5 +200,5 @@
   !  Choix du nombre de traceurs et du schema pour l'advection
   !  dans fichier traceur.def, par default ou via INCA
-  call init_infotrac
+  CALL init_infotrac
 
   ! Allocation de la tableau q : champs advectes   
@@ -254,5 +254,5 @@
      abort_message =  &
           'Il faut choisir un nb de pas par jour multiple de iperiod'
-     call abort_gcm(modname,abort_message,1)
+     CALL abort_gcm(modname,abort_message,1)
   ENDIF
 
@@ -260,5 +260,5 @@
      abort_message =  &
           'Il faut choisir un nb de pas par jour multiple de iphysiq'
-     call abort_gcm(modname,abort_message,1)
+     CALL abort_gcm(modname,abort_message,1)
   ENDIF
 
@@ -329,14 +329,14 @@
   mois = 1
   heure = 0.
-  call ymds2ju(annee_ref, mois, day_ref, heure, jD_ref)
+  CALL ymds2ju(annee_ref, mois, day_ref, heure, jD_ref)
   jH_ref = jD_ref - int(jD_ref)
   jD_ref = int(jD_ref)
 
-  call ioconf_startdate(INT(jD_ref), jH_ref)
+  CALL ioconf_startdate(INT(jD_ref), jH_ref)
 
   write(lunout,*)'DEBUG'
   write(lunout,*)'annee_ref, mois, day_ref, heure, jD_ref'
   write(lunout,*)annee_ref, mois, day_ref, heure, jD_ref
-  call ju2ymds(jD_ref+jH_ref,anref, moisref, jourref, heureref)
+  CALL ju2ymds(jD_ref+jH_ref,anref, moisref, jourref, heureref)
   write(lunout,*)'jD_ref+jH_ref,an, mois, jour, heure'
   write(lunout,*)jD_ref+jH_ref,anref, moisref, jourref, heureref
@@ -391,7 +391,7 @@
 
 #ifdef CPP_IOIPSL
-  call ju2ymds(jD_ref + day_ini - day_ref, an, mois, jour, heure)
+  CALL ju2ymds(jD_ref + day_ini - day_ref, an, mois, jour, heure)
   write (lunout,301)jour, mois, an
-  call ju2ymds(jD_ref + day_end - day_ref, an, mois, jour, heure)
+  CALL ju2ymds(jD_ref + day_end - day_ref, an, mois, jour, heure)
   write (lunout,302)jour, mois, an
 301 FORMAT('1'/,15x,'run du ', i2,'/',i2,'/',i4)
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/getparam.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/getparam.F90	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/getparam.F90	(revision 5101)
@@ -53,5 +53,5 @@
 
     ret_val=def_val
-    call getin(TARGET,ret_val)
+    CALL getin(TARGET,ret_val)
 
     IF (mpi_rank==0) THEN
@@ -79,5 +79,5 @@
 
     ret_val=def_val
-    call getin(TARGET,ret_val)
+    CALL getin(TARGET,ret_val)
 
     IF (mpi_rank==0) THEN
@@ -106,5 +106,5 @@
 
     ret_val=def_val
-    call getin(TARGET,ret_val)
+    CALL getin(TARGET,ret_val)
 
     IF (mpi_rank==0) THEN
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/gradiv2_loc.F
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/gradiv2_loc.F	(revision 5100)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/gradiv2_loc.F	(revision 5101)
@@ -66,8 +66,8 @@
 
 c$OMP BARRIER
-       call Register_Hallo_v(gdy,llm,1,0,0,1,Request_dissip)
-       call SendRequest(Request_dissip)
+       CALL Register_Hallo_v(gdy,llm,1,0,0,1,Request_dissip)
+       CALL SendRequest(Request_dissip)
 c$OMP BARRIER
-       call WaitRequest(Request_dissip)
+       CALL WaitRequest(Request_dissip)
 c$OMP BARRIER
 c
@@ -79,24 +79,24 @@
 
       CALL    divergf_loc( klevel, gdx,   gdy , div )
-c      call write_field3d_p('div1',reshape(div,(/iip1,jjp1,llm/)))
+c      CALL write_field3d_p('div1',reshape(div,(/iip1,jjp1,llm/)))
 
       IF( ld>1 )   THEN
 c$OMP BARRIER
-       call Register_Hallo_u(div,llm,1,1,1,1,Request_dissip)
-       call SendRequest(Request_dissip)
+       CALL Register_Hallo_u(div,llm,1,1,1,1,Request_dissip)
+       CALL SendRequest(Request_dissip)
 c$OMP BARRIER
-       call WaitRequest(Request_dissip)
+       CALL WaitRequest(Request_dissip)
 c$OMP BARRIER
 	CALL laplacien_loc( klevel, div,  div     )
 
 c    ......  Iteration de l'operateur laplacien_gam   .......
-c         call write_field3d_p('div2',reshape(div,(/iip1,jjp1,llm/)))
+c         CALL write_field3d_p('div2',reshape(div,(/iip1,jjp1,llm/)))
 
         DO iter = 1, ld -2
 c$OMP BARRIER
-       call Register_Hallo_u(div,llm,1,1,1,1,Request_dissip)
-       call SendRequest(Request_dissip)
+       CALL Register_Hallo_u(div,llm,1,1,1,1,Request_dissip)
+       CALL SendRequest(Request_dissip)
 c$OMP BARRIER
-       call WaitRequest(Request_dissip)
+       CALL WaitRequest(Request_dissip)
 
 c$OMP BARRIER
@@ -106,5 +106,5 @@
      &                          div, div       )
         ENDDO
-c        call write_field3d_p('div3',reshape(div,(/iip1,jjp1,llm/)))
+c        CALL write_field3d_p('div3',reshape(div,(/iip1,jjp1,llm/)))
       ENDIF
 
@@ -114,10 +114,10 @@
        CALL filtreg_p( div   ,jjb_u,jje_u,jjb,jje, jjp1, 
      &                 klevel, 2, 1, .TRUE., 1 )
-c       call exchange_Hallo(div,ip1jmp1,llm,0,1)
+c       CALL exchange_Hallo(div,ip1jmp1,llm,0,1)
 c$OMP BARRIER
-       call Register_Hallo_u(div,llm,1,1,1,1,Request_dissip)
-       call SendRequest(Request_dissip)
+       CALL Register_Hallo_u(div,llm,1,1,1,1,Request_dissip)
+       CALL SendRequest(Request_dissip)
 c$OMP BARRIER
-       call WaitRequest(Request_dissip)
+       CALL WaitRequest(Request_dissip)
 
 c$OMP BARRIER
Index: LMDZ6/branches/Amaury_dev/libf/dyn3dmem/groupe_loc.f90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3dmem/groupe_loc.f90	(revision 5101)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3dmem/groupe_loc.f90	(revision 5101)
@@ -0,0 +1,127 @@
+subroutine groupe_loc(pext, pbaru, pbarv, pbarum, pbarvm, wm)
+  USE parallel_lmdz
+  USE Write_field_loc
+  USE groupe_mod
+  USE comconst_mod, ONLY: ngroup
+  USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_DEBUGIO
+  implicit none
+
+  !   sous-programme servant a fitlrer les champs de flux de masse aux
+  !   poles en "regroupant" les mailles 2 par 2 puis 4 par 4 etc. au fur
+  !   et a mesure qu'on se rapproche du pole.
+  !
+  !   en entree: pext, pbaru et pbarv
+  !
+  !   en sortie:  pbarum,pbarvm et wm.
+  !
+  !   remarque, le wm est recalcule a partir des pbaru pbarv et on n'a donc
+  !   pas besoin de w en entree.
+
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom2.h"
+
+  ! integer ngroup
+  ! parameter (ngroup=3)
+
+  real :: pbaru(iip1, jjb_u:jje_u, llm), pbarv(iip1, jjb_v:jje_v, llm)
+  real :: pext(iip1, jjb_u:jje_u, llm)
+
+  real :: pbarum(iip1, jjb_u:jje_u, llm), pbarvm(iip1, jjb_v:jje_v, llm)
+  real :: wm(iip1, jjb_u:jje_u, llm)
+
+  real :: uu
+
+  integer :: i, j, l
+
+  logical :: firstcall
+  save firstcall
+  !$OMP THREADPRIVATE(firstcall)
+
+  integer :: ijb, ije, jjb, jje
+
+  !   Champs 1D
+
+  CALL convflu_loc(pbaru, pbarv, llm, zconvm)
+
+  !
+  !  CALL scopy(ijp1llm,zconvm,1,zconvmm,1)
+  !  CALL scopy(ijmllm,pbarv,1,pbarvm,1)
+
+  jjb = jj_begin
+  jje = jj_end
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  do l = 1, llm
+    zconvmm(:, jjb:jje, l) = zconvm(:, jjb:jje, l)
+  enddo
+  !$OMP END DO NOWAIT
+
+  CALL groupeun_loc(jjp1, llm, jjb_u, jje_u, jjb, jje, zconvmm)
+
+  jjb = jj_begin - 1
+  jje = jj_end
+  if (pole_nord) jjb = jj_begin
+  if (pole_sud)  jje = jj_end - 1
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  do l = 1, llm
+    pbarvm(:, jjb:jje, l) = pbarv(:, jjb:jje, l)
+  enddo
+  !$OMP END DO NOWAIT
+
+  IF (CPPKEY_DEBUGIO) THEN
+    CALL WriteField_v('pbarvm', reshape(pbarvm, (/ip1jm, llm/)))
+  END IF
+  CALL groupeun_loc(jjm, llm, jjb_v, jje_v, jjb, jje, pbarvm)
+  IF (CPPKEY_DEBUGIO) THEN
+    CALL WriteField_v('pbarvm', reshape(pbarvm, (/ip1jm, llm/)))
+  END IF
+  !   Champs 3D
+
+  jjb = jj_begin
+  jje = jj_end
+  if (pole_nord) jjb = jj_begin + 1
+  if (pole_sud)  jje = jj_end - 1
+
+  !$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  do l = 1, llm
+    do j = jjb, jje
+      uu = pbaru(iim, j, l)
+      do i = 1, iim
+        uu = uu + pbarvm(i, j, l) - pbarvm(i, j - 1, l) - zconvmm(i, j, l)
+        pbarum(i, j, l) = uu
+        ! zconvm(i,j,l ) =  xflu(i-1,j,l)-xflu(i,j,l)+
+        !    *                      yflu(i,j,l)-yflu(i,j-1,l)
+      enddo
+      pbarum(iip1, j, l) = pbarum(1, j, l)
+    enddo
+  enddo
+  !$OMP END DO NOWAIT
+  !    integration de la convergence de masse de haut  en bas ......
+
+  jjb = jj_begin
+  jje = jj_end
+
+  !$OMP BARRIER
+  !$OMP MASTER
+  do  l = llm - 1, 1, -1
+    do j = jjb, jje
+      do i = 1, iip1
+        zconvmm(i, j, l) = zconvmm(i, j, l) + zconvmm(i, j, l + 1)
+      enddo
+    enddo
+  enddo
+
+  if (.not. pole_sud) then
+    zconvmm(:, jj_end + 1, :) = 0
+    !ym	wm(:,jj_end+1,:)=0
+  endif
+
+  !$OMP END MASTER
+  !$OMP BARRIER
+
+  CALL vitvert_loc(zconvmm, wm)
+
+  return
+end subroutine groupe_loc
+
